import java.io.*;
import java.awt.*;
import java.awt.event.*;
import java.awt.image.*;
import java.util.*;

public class AkentiStart extends Frame implements ActionListener
{
  public AkentiStart()
  {
    Panel p = new Panel();

    resize( 580, 270 );
    setBackground(Color.white);

    start = new Button( "Start" );
    p.add( start );    
    start.addActionListener(this);

    close = new Button( "Close" );
    p.add( close );
    close.addActionListener(this);

    add(p, "South");

    imagedisp = new ImageDisplay();
    add(imagedisp, "Center");
  }


  public void actionPerformed(ActionEvent e)
  {
    String arg = e.getActionCommand();
    if(arg.equals("Start")) 
      {
	akentiinput = new AkentiInput();
      }
    else if(arg.equals("Close"))
      System.exit(0);
  }

  public static void main(String args[])
  {
    Frame f = new AkentiStart();
    f.show();
  }

  private ImageDisplay imagedisp;
  private Button start, close;
  private AkentiInput akentiinput;
}


/****************************************************************/
/////////////////////////////////////////////////////////////////

class ImageDisplay extends Canvas
{
  public ImageDisplay() {
    image = Toolkit.getDefaultToolkit().getImage("Akenti.home.jpeg");
  }

  public void paint(Graphics g)
  {
    g.drawImage(image, 0, 0, this);
  }
  
  private Image image;
}


/************************************************************/
/////////////////////////////////////////////////////////////

class AkentiInput extends Frame implements ActionListener 
{
  public AkentiInput()
  {
    System.out.println("Put your information on the frame");
    addWindowListener(new WindowAdapter() {
      public void windowClosing(WindowEvent e) {
	System.exit(0); } });
    resize( 400, 200 );

    setBackground(Color.white);
    setLayout( new GridLayout( 5, 2 ) );

      // create the components of the Frame
    DName = new TextField( "/C=US/O=Northeast Parallel Architectures Center/OU=Gateway Project/CN=Choonhan Youn" , 200 );
    DNameLabel = new Label( "Distinguish Name" );
    Resource = new TextField( "cyoun" , 200 );
    ResourceLabel = new Label( "Resource" );
    ConfFile = new TextField( "/home/T11F/webflow/Akenti/conf/Akenti.conf" , 200 );
    ConfFileLabel = new Label( "Configuration File" );
    LocalResourceRoot = new TextField( "/home/T11F/webflow/Akenti/akenti-docs/", 200 );
    LocalResourceRootLabel = new Label ( "LocalReourceRoot" );
    enter = new Button( "Enter" );
    enter.addActionListener(this);
    reset = new Button( "Reset" );
    reset.addActionListener(this);

      // add the components to the Frame
    add( DNameLabel );  
    add( DName );     
    add( ResourceLabel );   
    add( Resource );   
    add( ConfFileLabel );   
    add( ConfFile );     
    add( LocalResourceRootLabel ); 
    add( LocalResourceRoot ); 
    add( enter );    
    add( reset );

    show();             // show the Frame

  }

  public void actionPerformed(ActionEvent e)
  {
    String arg = e.getActionCommand();
    String cmd;
    if(arg.equals("Enter")) 
      {
	DNameStr = new String( DName.getText() );
        ResourceStr = new String( Resource.getText() );
	ConfFileStr = new String( ConfFile.getText() );
	LocalResourceRootStr = new String( LocalResourceRoot.getText() );

	String dquote = "\"";
	DNameStr = dquote.concat(DNameStr);
	DNameStr = DNameStr.concat(dquote);

	ResourceStr = dquote.concat(ResourceStr);
	ResourceStr = ResourceStr.concat(dquote);

	System.out.println("DName = "+DNameStr);
	System.out.println("Resource = "+ResourceStr);
	System.out.println("ConfFile = "+ConfFileStr);
	System.out.println("LocalResourceRoot = "+LocalResourceRootStr);

	cmd = "akenti_chk_acc -t W -n "+DNameStr+" -r "+ResourceStr+" -f "+ConfFileStr+" -d "+LocalResourceRootStr+" > akentiresult";
	String  Akentiscript = "/home/T11F/webflow/Akenti/akenti-docs/cgi-bin/akentiscript";
	System.out.println("CMD= "+cmd);

	String FileContents = new String("#!/bin/sh -f\n");
	FileContents += cmd+"\n";
  
	int scriptsize = FileContents.length();
	byte[] scriptbuf = new byte[scriptsize];
	FileContents.getBytes(0, scriptsize, scriptbuf, 0);

	File to_file = new File(Akentiscript);
	FileOutputStream to = null;

	try{
	  to = new FileOutputStream(to_file);
	  to.write(scriptbuf, 0, scriptsize);
	}
	catch(IOException exc){;}
	finally{
	  if(to != null) try{to.close();} catch(IOException exc) {;}
	}    


	try{
	  Process AkentiEnv = Runtime.getRuntime().exec("chmod 777 "+Akentiscript);
	  AkentiEnv.waitFor();
	  Process AkentiExec = Runtime.getRuntime().exec(Akentiscript);
	  AkentiExec.waitFor();
	}
	catch (Exception ex) {
	  System.err.println("Error: " + ex.toString());
	}

	akentiaccesscheck = new AkentiAccessCheck();
	akentiaccesscheck.AkentiResultDelete();
      }

    else {
      DName.setText( "" );
      Resource.setText( "" );
      ConfFile.setText( "" );
      LocalResourceRoot.setText( "" ); }
  }

  private TextField DName, 
                    Resource,
                    ConfFile,
                    LocalResourceRoot;

  private Button enter,       
                 reset;
  private Label DNameLabel,
                ResourceLabel,
                ConfFileLabel,
                LocalResourceRootLabel;

  private String DNameStr,
		 ResourceStr,
		 ConfFileStr,
		 LocalResourceRootStr;

  private AkentiAccessCheck akentiaccesscheck;
}


/***********************************************************************/
/////////////////////////////////////////////////////////////////////////

class AkentiAccessCheck
{
  public AkentiAccessCheck(){
    File f = new File("/home/T11F/webflow/Akenti/akenti-docs/cgi-bin/akentiresult");
    int size = (int) f.length();
    int bytes_read = 0;
    boolean AkentiAccessType = false;
    String tem_data;
	
    try{
      FileInputStream in = new FileInputStream(f);
      byte[] data = new byte[size];
      while(bytes_read < size)
	bytes_read += in.read(data, bytes_read, size-bytes_read);
      tem_data = new String(data);
      int indexNum = tem_data.indexOf("Allowed actions:");
      String action = tem_data.substring(indexNum+16);
      System.out.println(action);
      if (action.startsWith("none")) AkentiAccessType = false;
      else if (action.startsWith("read") || action.startsWith("execute") || action.startsWith("write") || action.startsWith("add") || action.startsWith("delete")) AkentiAccessType = true;
      else System.out.println("System error!!!!!!!");
      if (AkentiAccessType) System.out.println("This user has access rights");
      else System.out.println("This user can not access this resource!!!");
    } catch (IOException e) {
      System.err.println("Error: " + e.toString());
    }
  }

  void AkentiResultDelete() {
    
    String  Akentiresult = "/home/T11F/webflow/Akenti/akenti-docs/cgi-bin/akentiresult";
    String  Akentiscript = "/home/T11F/webflow/Akenti/akenti-docs/cgi-bin/akentiscript";
 
    try{
      Process AkentiDelete = Runtime.getRuntime().exec("rm -r "+Akentiresult);
      AkentiDelete.waitFor(); 
      Process AkentiSDelete = Runtime.getRuntime().exec("rm -r "+Akentiscript);
      AkentiDelete.waitFor(); 
    }
    catch (Exception ex1) {
      System.err.println("Error: " + ex1.toString());
    }
  }

}



















